<?php
namespace codeneric\phmm {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\base\admin\FrontendHandler;
  use \codeneric\phmm\base\includes\Error;
  require_once (dirname(__FILE__)."/update_functions.php");
  class DBUpdater {
    static $currVersion;
    static function version_to_func_name($newVersion) {
      $tempNew = str_replace(".", "_", $newVersion);
      return "update_to_".$tempNew;
    }
    static function update($config) {
      DBUpdater::$currVersion = $config[\hacklib_id("version")];
      $oldVersion = get_option("cc_photo_manage_curr_version", "1.0.1");
      \HH\invariant(
        is_string($oldVersion),
        "%s",
        new Error(
          "String expected",
          array(array("oldVersion", $oldVersion))
        )
      );
      if (get_option("cc_photo_manage_id") === false) {
        $uniqid = uniqid("", true);
        $uniqid = str_replace(".", "", $uniqid);
        update_option("cc_photo_manage_id", $uniqid);
      }
      $funcContainer = new FunctionContainer();
      $funcContainer->legacy($config);
      if ($oldVersion === DBUpdater::$currVersion) {
        return;
      }
      flush_rewrite_rules();
      update_option("cc_photo_manage_curr_version", DBUpdater::$currVersion);
      $functions = get_class_methods(FunctionContainer::class);
      $funcName = DBUpdater::version_to_func_name($oldVersion);
      if (!\hacklib_cast_as_boolean(is_array($functions))) {
        return;
      }
      $filterFunctions = function($v) {
        return strpos($v, "update_to_") === 0;
      };
      $update_funcs = array_filter($functions, $filterFunctions);
      $update_funcs[] = $funcName;
      $update_funcs = array_unique($update_funcs);
      natsort($update_funcs);
      $update_funcs = array_values($update_funcs);
      $oldVersionIndex = array_search($funcName, $update_funcs);
      for ($i = $oldVersionIndex + 1; $i < count($update_funcs); $i++) {
        $funcName = $update_funcs[$i];
        if (\hacklib_cast_as_boolean(
              method_exists($funcContainer, $funcName)
            )) {
          $funcContainer->$funcName($config);
        }
      }
      do_action("codeneric/phmm/base-plugin-updated");
    }
  }
}
