<?php
namespace codeneric\phmm {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\base\admin\FrontendHandler;
  use \codeneric\phmm\base\includes\Error;
  use \codeneric\phmm\base\globals\Superglobals;
  require_once (dirname(__FILE__)."/admin.php");
  require_once
    (dirname(__FILE__)."/../protect_images/generate_htaccess.php")
  ;
  require_once (ABSPATH."wp-admin/includes/upgrade.php");
  require_once (dirname(__FILE__)."/schema/legacy/read_3_6_5.php");
  require_once (dirname(__FILE__)."/schema/legacy/map.php");
  require_once (dirname(__FILE__)."/schema/legacy/write_4_0_0.php");
  require_once (dirname(__FILE__)."/schema/legacy/legacy_validators.php");
  class FunctionContainer {
    public function update_to_1_1_0() {
      $options = get_option("cc_photo_settings", array());
      \HH\invariant(is_array($options), "%s", new Error("Expected array."));
      $options[\hacklib_id("cc_photo_image_box")] = 1;
      $options[\hacklib_id("cc_photo_download_text")] = "Download all";
      update_option("cc_photo_settings", $options);
      $posts_array = get_posts("post_type=client");
      foreach ($posts_array as $client) {
        $projects = get_post_meta($client->ID, "projects", true);
        $projects =
          \hacklib_cast_as_boolean(is_array($projects)) ? $projects : array();
        foreach ($projects as $k => $project) {
          $projects[$k][\hacklib_id("downloadable")] = true;
        }
        update_post_meta($client->ID, "projects", $projects);
      }
    }
    public function update_to_2_2_2() {
      if (get_option("codeneric_phmm_error_log") === false) {
        update_option("codeneric_phmm_error_log", array());
      }
    }
    public function update_to_2_3_0() {
      add_role(
        "phmm_client",
        __("PhMm Client"),
        array(
          "read" => true,
          "edit_posts" => false,
          "delete_posts" => false
        )
      );
    }
    public function update_to_2_7_0() {
      $upload_dir = wp_upload_dir();
      $upload_dir =
        $upload_dir[\hacklib_id("basedir")]."/photography_management";
      if (\hacklib_cast_as_boolean(is_link($upload_dir."/protect.php"))) {
        unlink($upload_dir."/protect.php");
      }
      if (\hacklib_cast_as_boolean(is_link($upload_dir."/.htaccess"))) {
        unlink($upload_dir."/.htaccess");
      }
      if (\hacklib_cast_as_boolean(file_exists($upload_dir."/.htaccess"))) {
        unlink($upload_dir."/.htaccess");
      }
      Photography_Management_Base_Generate_Htaccess($upload_dir."/.htaccess");
    }
    public function update_to_3_2_6() {
      $upload_dir = wp_upload_dir();
      $upload_dir =
        $upload_dir[\hacklib_id("basedir")]."/photography_management";
      if (\hacklib_cast_as_boolean(file_exists($upload_dir."/.htaccess"))) {
        unlink($upload_dir."/.htaccess");
      }
      Photography_Management_Base_Generate_Htaccess($upload_dir."/.htaccess");
    }
    public function update_to_3_5_0($cc_phmm_config) {
      $query_args = array(
        "posts_per_page" => -1,
        "offset" => 0,
        "post_type" => $cc_phmm_config[\hacklib_id("client_post_type")]
      );
      $posts_array = get_posts($query_args);
      foreach ($posts_array as $client) {
        $projects = get_post_meta($client->ID, "projects", true);
        $projects =
          \hacklib_cast_as_boolean(is_array($projects)) ? $projects : array();
        foreach ($projects as $k => $project) {
          $uniqid = uniqid("", true);
          $uniqid = str_replace(".", "", $uniqid);
          if (\hacklib_cast_as_boolean(/* UNSAFE_EXPR */
                (!isset($projects[$k][\hacklib_id("id")])) ||
                \hacklib_equals($projects[$k][\hacklib_id("id")], false)
              )) {
            $projects[$k][\hacklib_id("id")] = $uniqid;
          }
        }
        update_post_meta($client->ID, "projects", $projects);
      }
    }
    public function update_to_4_0_0() {
      $wpdb = Superglobals::Globals("wpdb");
      \HH\invariant(
        $wpdb instanceof \wpdb,
        "%s",
        new Error("wpdb is not available!")
      );
      $charset_collate = $wpdb->get_charset_collate();
      $table_name = "codeneric_phmm_comments";
      $sql =
        "CREATE TABLE ".
        $table_name.
        " (\n\t\t  id   bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,\n\t\t  time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n\t\t  content   text DEFAULT '' NOT NULL,\n\t\t  project_id   bigint(20) UNSIGNED NOT NULL,\n\t\t  attachment_id   bigint(20) UNSIGNED NOT NULL,\n\t\t  wp_user_id   bigint(20) UNSIGNED NOT NULL,\n\t\t  client_id   bigint(20) UNSIGNED NOT NULL,\n          wp_author_id   bigint(20) UNSIGNED NOT NULL,\n\t\t  UNIQUE KEY id (id)\n\t\t) ".
        $charset_collate.
        ";";
      dbDelta(/* UNSAFE_EXPR */ $sql);
      try {
        $plugin_settings =
          \codeneric\phmm\legacy\v3_6_5\read_plugin_settings();
        $plugin_settings_4_0_0 =
          \codeneric\phmm\legacy\map_plugin_settings_from_3_6_5(
            $plugin_settings
          );
        update_option(
          "codeneric_phmm_plugin_settings",
          $plugin_settings_4_0_0
        );
      } catch (\Exception $e) {
      }
      $query_args = array(
        "posts_per_page" => -1,
        "offset" => 0,
        "post_type" => "client"
      );
      $posts_array = get_posts($query_args);
      foreach ($posts_array as $client_post) {
        $client = get_post_meta($client_post->ID, "client", true);
        try {
          $client =
            \codeneric\phmm\legacy\validate\client_data_representation_3_6_5(
              $client
            );
          $projects =
            \codeneric\phmm\legacy\v3_6_5\read_projects($client_post->ID);
          $project_ids = array();
          foreach ($projects as $key => $project) {
            $project_4_0_0 = \codeneric\phmm\legacy\map_project_from_3_6_5(
              $project,
              $client[\hacklib_id("pwd")],
              false
            );
            $pid = wp_insert_post(
              array(
                "post_title" => $project[\hacklib_id("title")],
                "post_type" => "project",
                "post_status" => get_post_status($client_post->ID),
                "post_password" => $client[\hacklib_id("pwd")],
                "post_content" => $project[\hacklib_id("description")]
              )
            );
            if (\hacklib_cast_as_boolean(is_int($pid)) && ($pid !== 0)) {
              \codeneric\phmm\legacy\v4_0_0\save_project(
                $pid,
                $project_4_0_0
              );
              $project_ids[] = $pid;
              if (!\hacklib_cast_as_boolean(
                    is_null($client[\hacklib_id("wp_user_id")])
                  )) {
                foreach ($project[\hacklib_id("gallery")] as $i) {
                  $comments = \codeneric\phmm\legacy\v3_6_5\read_comments($i);
                  foreach ($comments as $c) {
                    $wp_user_id = $client[\hacklib_id("wp_user_id")];
                    $wp_user_id_of_client =
                      (!\hacklib_cast_as_boolean(is_null($wp_user_id)))
                        ? $wp_user_id
                        : 0;
                    $comment_4_0_0 =
                      \codeneric\phmm\legacy\map_comment_from_3_6_5(
                        $c,
                        $pid,
                        $wp_user_id_of_client
                      );
                    \codeneric\phmm\legacy\v4_0_0\save_comment(
                      $comment_4_0_0
                    );
                  }
                }
                \codeneric\phmm\legacy\v4_0_0\save_lable_set(
                  $client_post->ID,
                  $pid,
                  $project[\hacklib_id("starred")]
                );
              }
            }
          }
          if (!\hacklib_cast_as_boolean(
                is_null($client[\hacklib_id("wp_user_id")])
              )) {
            update_post_meta(
              $client_post->ID,
              "wp_user",
              $client[\hacklib_id("wp_user_id")]
            );
            $client_4_0_0 = \codeneric\phmm\legacy\map_client_from_3_6_5(
              $client,
              $project_ids
            );
            \codeneric\phmm\legacy\v4_0_0\save_client(
              $client_post->ID,
              $client_4_0_0
            );
          }
        } catch (\Exception $e) {
        }
      }
    }
    public function decouple_projects() {
      $query_args = array(
        "posts_per_page" => -1,
        "offset" => 0,
        "post_type" => "client"
      );
      $posts_array = get_posts($query_args);
      foreach ($posts_array as $client) {
        $projects = get_post_meta($client->ID, "projects", true);
        $projects =
          \hacklib_cast_as_boolean(is_array($projects)) ? $projects : array();
        foreach ($projects as $key => $project) {
        }
        update_post_meta($client->ID, "projects", $projects);
      }
      update_option("decoupled_projects", "done");
    }
    public function legacy($cc_phmm_config) {
      $p = get_option("cc_prem");
      if (\hacklib_cast_as_boolean($p) &&
          (!\hacklib_cast_as_boolean(
             $cc_phmm_config[\hacklib_id("has_premium_ext")]
           ))) {
        $cc_phmm_base_admin_notice_update_to_premium =
          function() {
            $class = "notice notice-error";
            $prem_url = admin_url("edit.php");
            $prem_url = add_query_arg(
              array("post_type" => "client", "page" => "premium"),
              $prem_url
            );
            $p_url = admin_url("plugins.php");
            $message =
              "Please <a id=\"cc_phmm_install_notice\" href=\"".
              $prem_url.
              "\" data-plugins-url=\"".
              $p_url.
              "\" >install</a> the Photography Management Premium extension!";
            wp_enqueue_script(
              "cc_phmm_admin_notice",
              plugin_dir_url(__FILE__)."/partials/admin_notice.js"
            );
            $spinner =
              "<div id=\"cc_phmm_notice_spinner\" style=\"background:url('images/spinner.gif') no-repeat;background-size: 20px 20px;vertical-align: middle;margin: 0 auto;height: 20px;width: 20px;display:none;\"></div>";
            echo
              ("<div id=\"cc_phmm_notice_wrap\" class=\"".
               $class.
               "\"> <p>".
               $spinner.
               " ".
               $message.
               "</p></div>")
            ;
          };
        add_action(
          "admin_notices",
          $cc_phmm_base_admin_notice_update_to_premium
        );
      } else {
        if (\hacklib_cast_as_boolean(
              $cc_phmm_config[\hacklib_id("has_premium_ext")]
            ) &&
            (!\hacklib_cast_as_boolean(
               $cc_phmm_config[\hacklib_id("premium_ext_active")]
             ))) {
          $cc_phmm_base_admin_notice_update_to_premium =
            function() {
              $class = "notice notice-error";
              $d_url = admin_url("plugins.php");
              $message =
                "Please <a href=\"".
                $d_url.
                "\" >activate</a> the Photography Management Premium extension!";
              $script = "";
              echo
                ("<div id=\"cc_phmm_notice_wrap\" class=\"".
                 $class.
                 "\"> <p>".
                 $message.
                 "</p></div>".
                 $script)
              ;
            };
          add_action(
            "admin_notices",
            $cc_phmm_base_admin_notice_update_to_premium
          );
        }
      }
    }
  }
}
